function [r_minus,r_plus]=script_proof_Floquet(j)

load gamma

if j==1, load x1, x=x1; end
if j==2, load x2, x=x2; end
if j==3, load x3, x=x3; end
if j==4, load x4, x=x4; end

%nu=intval('1.3');
%beta=intval('0.05'); %%% The weight = 1/20 in the norm ||x||^beta_X 

nu=intval(1.001); beta=1;

r_gamma=intval('7.595549832526767e-13');

m_gamma=16;

extra_dim=1280; %%% In this way, m=56>3*m_gamma-2 = 46

[tx]=padding(tx,extra_dim);
[x]=padding_Floquet(x,extra_dim);

[P]=int_rad_poly_Floquet(x,tx,nu,r_gamma,m_gamma,beta);

R0=sort(transpose(roots(P(1,:))));
R1=sort(transpose(roots(P(2,:))));
R2=sort(transpose(roots(P(3,:))));
R3=sort(transpose(roots(P(4,:))));
R4=sort(transpose(roots(P(5,:))));

I0=infsup(R0(1),R0(2));
I1=infsup(R1(1),R1(2));
I2=infsup(R2(1),R2(2));
I3=infsup(R3(1),R3(2));
I4=infsup(R4(1),R4(2));

I=intersect(intersect(intersect(intersect(I0,I1),I2),I3),I4);

%%% Making sure p_i(r_minus), p_i(r_plus)<0 %%%

r_minus=(1.001)*inf(I);
r_plus=(0.99)*sup(I);

iP=intval(P);
ir_minus=intval(r_minus);
ir_plus=intval(r_plus);

iP0_r_min=sup(sum(iP(1,:).*ir_minus.^(2:-1:0)));
iP1_r_min=sup(sum(iP(2,:).*ir_minus.^(2:-1:0)));
iP2_r_min=sup(sum(iP(3,:).*ir_minus.^(2:-1:0)));
iP3_r_min=sup(sum(iP(4,:).*ir_minus.^(2:-1:0)));
iP4_r_min=sup(sum(iP(5,:).*ir_minus.^(2:-1:0)));
max_1=max([iP0_r_min iP1_r_min iP2_r_min iP3_r_min iP4_r_min]);

iP0_r_plus=sup(sum(iP(1,:).*ir_plus.^(2:-1:0)));
iP1_r_plus=sup(sum(iP(2,:).*ir_plus.^(2:-1:0)));
iP2_r_plus=sup(sum(iP(3,:).*ir_plus.^(2:-1:0)));
iP3_r_plus=sup(sum(iP(4,:).*ir_plus.^(2:-1:0)));
iP4_r_plus=sup(sum(iP(5,:).*ir_plus.^(2:-1:0)));
max_2=max([iP0_r_plus iP1_r_plus iP2_r_plus iP3_r_plus iP4_r_plus]);

max_P=max([max_1 max_2]);

if max_P<0,
    display('Success with the Floquet proof.')
    display(['I = [',num2str(r_minus),' , ',num2str(r_plus),']'])
else
    display('Failure with the Floquet proof.')
end

rad=infsup(-r_minus,r_minus);
lambda=x(1)+rad;

rad_gamma=infsup(-inf(r_gamma),sup(r_gamma));
frequency=tx(1)+rad_gamma;
tau=2*intval('pi')/frequency;

Floquet_multiplier = exp(lambda*tau);
display(['Floquet multipler = ',num2str(real(mid(Floquet_multiplier)))])

if sup(abs(Floquet_multiplier))<1
    display('Success: the Floquet multipler is STABLE !')
elseif inf(abs(Floquet_multiplier))>1
    display('Success: the Floquet multipler is UNSTABLE !')
end

end
    
