function [F]=int_F_PO_blow_up(x)

%%% input: x = (L,a), where
%%%    - L is the (complex) frequency of the periodic solution
%%%    - a is the vector of Fourier coefficients in C^(2m-1)

m=length(x)/2;

L = x(1); %%% The frequency of the periodic orbit
a = x(2:end);

[a3]=int_cubic_sumFFTcomplex(a,a,a);

k=intval(-m+1:m-1)';
mu=L^4*k.^4-14*1i*L^3*k.^3-71*L^2*k.^2+154*1i*L*k+120;

F0=sum(a(m-3:m+3)); % F0 = sum_{|k|<=3} a_k, since u(0) approx 0 (phase condition)

F1=mu.*a+a3;

F=[F0;F1];

end