function []=plot_periodic_complex(x)

L=real(x(1));
period=2*pi/abs(x(1));
m=length(x)/2;
a=real(x(m+1:end));
b=imag(x(m+1:end));

plot((0:.001:period),periodic(L,a,b,(0:.001:period)),'Color',[0 0 1],'LineWidth',3)
box off
hold on
plot([0 period],[0 0],'color',[0 0 0])
set(gca,'FontSize',15)
title('Graph of \gamma(t)','FontSize',20)
xlabel('t','FontSize',20)
ylabel('\gamma(t)','FontSize',20)

end

function [periodic]=periodic(L,a,b,t)

m=length(a);

sum=0;
for k=1:m-1
    sum=sum+a(k+1,1)*cos(k*L*t)-b(k+1,1)*sin(k*L*t);
end
periodic=a(1,1)+2*sum;

end