load gamma
nu=intval('1.3');

[P]=int_rad_poly_gamma(tx,nu);

R0=roots(P(1,:));
R1=roots(P(2,:));

I0=infsup(R0(5),R0(4));
I1=infsup(R1(5),R1(4));

I=intersect(I0,I1);

%%% Making sure p_i(r_minus), p_i(r_plus)<0 %%%

r_minus=(1.001)*inf(I);
r_plus=(0.99)*sup(I);

iP=intval(P);
ir_minus=intval(r_minus);
ir_plus=intval(r_plus);

iP1_at_r_minus=sup(sum(iP(1,:).*ir_minus.^(5:-1:0)));
iP2_at_r_minus=sup(sum(iP(2,:).*ir_minus.^(5:-1:0)));

iP1_at_r_plus=sup(sum(iP(1,:).*ir_plus.^(5:-1:0)));
iP2_at_r_plus=sup(sum(iP(2,:).*ir_plus.^(5:-1:0)));

max_P=max([iP1_at_r_minus iP2_at_r_minus iP1_at_r_plus iP2_at_r_plus]);

if max_P<0,
    display('Success with the proof !')
    display(['I = [',num2str(r_minus),' , ',num2str(r_plus),']'])
    plot_periodic_complex(tx)
    axis tight
else
    display('Failure with the proof !')
end





