clear
load gamma
nu=intval('1.3');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [0 .25], gamma'(t)<0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T_mesh_minus=[0 .16 .23 .25];
n1=length(T_mesh_minus);
sign1=zeros(1,n1-1);

for k=1:n1-1
    t=infsup(T_mesh_minus(k),T_mesh_minus(k+1));
    sign1(k)=value_of_gamma_prime(t,tx,nu);
end

if max(sign1)>=0,
    display('error!')
    return
else
    display(['gamma_prime < 0 on [',num2str(0),' , ',num2str(.25),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [.25 .28], gamma''(t)>0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This shows that there is a unique zero in [.25 .28]

[sign2]=value_of_gamma_prime_prime(infsup(.25,.28),tx,nu);

if sign2<=0,
    display('error!')
    return
else
    display(['gamma_prime_prime > 0 on [',num2str(.25),' , ',num2str(.28),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [.28 .74], gamma'(t)>0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T_mesh_plus=[.28 .38 .56 .69 .74];
n3=length(T_mesh_plus);
sign3=zeros(1,n3-1);

for k=1:n3-1
    t=infsup(T_mesh_plus(k),T_mesh_plus(k+1));
    sign3(k)=value_of_gamma_prime(t,tx,nu);
end

if max(sign3)<=0,
    display('error!')
    return
else
    display(['gamma_prime > 0 on [',num2str(.28),' , ',num2str(.74),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [.74 .78], gamma''(t)<0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[sign4]=value_of_gamma_prime_prime(infsup(.74,.78),tx,nu);

if sign4>=0,
    display('error!')
    return
else
    display(['gamma_prime_prime > 0 on [',num2str(.74),' , ',num2str(.78),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% On [.78 1], gamma'(t)<0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T_mesh_minus=[.78 .88 1];
n5=length(T_mesh_minus);
sign5=zeros(1,n5-1);

for k=1:n5-1
    t=infsup(T_mesh_minus(k),T_mesh_minus(k+1));
    sign5(k)=value_of_gamma_prime(t,tx,nu);
end

if max(sign5)>=0,
    display('error!')
    return
else
    display(['gamma_prime < 0 on [',num2str(.78),' , ',num2str(1),']'])
end

