

function [f,f_int,Jac, Jac_int, alphas]=compute_fN_manifold_bridge(alphas,lambda, T)

N=size(alphas,1)-1;
m=(size(alphas(2).fc,2)+1)/2;

vec_al=[]; % as N=n_1+n_2 increases, list from the higher n_1%
for modN=2:N
    for al1=modN:-1:0
        al2=modN-al1;
        a_al=(alphas(al1+1,al2+1).fc).';
        vec_al=[vec_al;reshape(a_al,[],1)];
    end
end

f=compute_map(alphas,lambda, T);
disp(['Inf-norm of F=', num2str(norm(f,inf))])
while norm(f,inf)>10^-15
Jac=compute_gradient(alphas,lambda, T);



vec_al=vec_al-Jac\f;

% reconstruct alphas
Mat_al=reshape(vec_al,2*m-1,[]);
cont=1;
for modN=2:N
    for al1=modN:-1:0
        al2=modN-al1;
        alphas(al1+1,al2+1).fc=Mat_al(:,cont:cont+3).';
        cont=cont+4;
    end
end


f=compute_map(alphas,lambda, T);
disp(['Inf-norm of F=', num2str(norm(f,inf))])
end

f=compute_map(alphas,lambda, T);
f_int=compute_map_int(alphas,lambda, T);
Jac=compute_gradient(alphas,lambda, T);
Jac_int=compute_gradient_int(alphas,lambda, T);


disp('Jac is the approximate Jacobian');
disp('Jac_int is the intval jacobian');
end

%%%%%%%%%%%%%%%%
    function fN=compute_map(alphas,lambda, T)

N=size(alphas,1)-1;
m=(size(alphas(1).fc,2)+1)/2;
dim_man=length(lambda);

        fN=[];
       
for modN=2:N 
    for al1=modN:-1:0
        al2=modN-al1;
        al=[al1,al2];
        a1a1a1=compute_cubic([1,1,1],al,alphas);
        ma3=(length(a1a1a1)+1)/2;
        a1a1a1=a1a1a1(ma3+[-m+1:m-1]);
        position=num2cell(al+ones(1,dim_man));
        a_al=getfield(alphas,position,'fc').';

    f_ak=(pi*1i/(T)*repmat([-m+1:1:m-1].',1,4)+al*lambda.').*a_al-[a_al(:,2),a_al(:,3),a_al(:,4),-120*a_al(:,1)-a1a1a1.'-154*a_al(:,2)-71*a_al(:,3)-14*a_al(:,4)];
                                                                
    fN=[fN;reshape(f_ak,[],1)];
    end

end
    end
    
    %%%%%%%%%%%%%%%%%%%%%
      function fN=compute_map_int(alphas,lambda, T)
ipi=intval('pi');
iT=intval(T);
ilambda=intval(lambda);


N=size(alphas,1)-1;
m=(size(alphas(1).fc,2)+1)/2;
dim_man=length(lambda);


        fN=[];
       
for modN=2:N  
    for al1=modN:-1:0
        al2=modN-al1;
        al=[al1,al2];
        a1a1a1=compute_cubic_int([1,1,1],al,alphas);
        position=num2cell(al+ones(1,dim_man));
        a_al=intval(getfield(alphas,position,'fc').');
        a_al=[intval(zeros(m-1,4));a_al;intval(zeros(m-1,4))];
        a_al=[intval(zeros(m-1,4));a_al;intval(zeros(m-1,4))];
        
    f_ak=(ipi*1i/(iT)*intval(repmat([-3*m+3:1:3*m-3].',1,4))+intval(al)*ilambda.').*a_al-[a_al(:,2),a_al(:,3),a_al(:,4),-intval(120)*a_al(:,1)-a1a1a1.'-intval(154)*a_al(:,2)-intval(71)*a_al(:,3)-intval(14)*a_al(:,4)];
                                                                
    fN=[fN;reshape(f_ak,[],1)];
    end

end
    end

    %%%%%%%%%%%%%%%%%%%%%%
    
function Jacobian=compute_gradient(alphas,lambda, T)


N=size(alphas,1)-1;
m=(size(alphas(1).fc,2)+1)/2;


Id=eye(2*m-1);
n=(N^2+3*N+2)/2-2-1;    % number of possible (a_1,a_2) with length=modN, modN=2... N
Jacobian=zeros(4*n*(2*m-1));

cont2=0;
for modNa=2:N
    for al1=modNa:-1:0
        al2=modNa-al1;
        a=[al1,al2];
        Ja=zeros(4*(2*m-1),4*n*(2*m-1));
       
        cont=0;
        for modNb=2:N
            for bl1=modNb:-1:0
                bl2=modNb-bl1;
                b=[bl1,bl2];
                Jab=zeros(4*(2*m-1));
                   for i=1:4
                     for j=1:4
                          Jabij=zeros(2*m-1);
                         if prod(a==b)==1      %linear part
                             if i==1
                                 if j==1
                                     Jabij=2*pi/(2*T)*1i*diag(-m+1:1:m-1)+a*lambda.'*Id;
                                 elseif j==2
                                     Jabij=-Id;
                                 end
                             elseif i==2
                                 if j==2
                                     Jabij=2*pi/(2*T)*1i*diag(-m+1:1:m-1)+a*lambda.'*Id;
                                 elseif j==3
                                     Jabij=-Id;
                                 end
                            elseif i==3
                                 if j==3
                                     Jabij=2*pi/(2*T)*1i*diag(-m+1:1:m-1)+a*lambda.'*Id;
                                 elseif j==4
                                     Jabij=-Id;
                                 end
                             elseif i==4
                                 if j==1
                                     Jabij=120*Id;
                                 elseif j==2
                                     Jabij=154*Id;
                                 elseif j==3
                                     Jabij=71*Id;
                                 elseif j==4
                                     Jabij=2*pi/(2*T)*1i*diag(-m+1:1:m-1)+a*lambda.'*Id+14*Id;
                                 end
                             end
                         else
                             Jabij=zeros(2*m-1);
                         end
                         
                         if i==4 && j==1  %nonlinear part
                             if prod(a-b>=0)==1
                             A2=compute_quad([1,1],a-b,alphas);
                             mA2=(length(A2)+1)/2;
                             A2=A2(mA2+[-m+1:m-1]);
                             Jabij=Jabij+3*tildeMat(A2);
                             end
                         end
                         Jab((i-1)*(2*m-1)+1:i*(2*m-1),(j-1)*(2*m-1)+1:j*(2*m-1))=Jabij;
%       
            
                      end
                   end
                  
                   Ja(:,4*(2*m-1)*cont+[1:4*(2*m-1)])=Jab;
                   cont=cont+1;
   
            end
        end
        Jacobian(cont2*4*(2*m-1)+[1:4*(2*m-1)],:)=Ja;
     
        cont2=cont2+1;
    end
end
end

   %%%%%%%
   
   function Jacobian=compute_gradient_int(alphas,lambda, T)

iT=intval(T);
ilambda=intval(lambda);
ipi=intval('pi');
i3=intval(3);


N=size(alphas,1)-1;
m=(size(alphas(1).fc,2)+1)/2;
dim_man=length(lambda);

Id=eye(2*m-1);
n=(N^2+3*N+2)/2-2-1;    % number of possible (a_1,a_2) with length=modN, modN=2... N
Jacobian=intval(zeros(4*n*(2*m-1)));
cont2=0;
for modNa=2:N
    for al1=modNa:-1:0
        al2=modNa-al1;
        a=[al1,al2];
        Ja=intval(zeros(4*(2*m-1),4*n*(2*m-1)));
       
        cont=0;
       
        for modNb=2:N
            for bl1=modNb:-1:0
                bl2=modNb-bl1;
                b=[bl1,bl2];
                Jab=intval(zeros(4*(2*m-1)));
                   for i=1:4
                     for j=1:4
                         Jabij=zeros(2*m-1);
                         if prod(a==b)==1      %linear part
                             if i==1
                                 if j==1
                                     Jabij=ipi/(iT)*1i*intval(diag(-m+1:1:m-1))+intval(a)*ilambda.'*Id;
                                 elseif j==2
                                     Jabij=-Id;
                                 end
                             elseif i==2
                                 if j==2
                                     Jabij=ipi/(iT)*1i*intval(diag(-m+1:1:m-1))+intval(a)*ilambda.'*Id;
                                 elseif j==3
                                     Jabij=-Id;
                                 end
                            elseif i==3
                                 if j==3
                                     Jabij=ipi/(iT)*1i*intval(diag(-m+1:1:m-1))+intval(a)*ilambda.'*Id;
                                 elseif j==4
                                     Jabij=-intval(Id);
                                 end
                             elseif i==4
                                 if j==1
                                     Jabij=intval(120)*Id;
                                 elseif j==2
                                     Jabij=intval(154)*Id;
                                 elseif j==3
                                     Jabij=intval(71)*Id;
                                 elseif j==4
                                     Jabij=ipi/(iT)*1i*intval(diag(-m+1:1:m-1))+intval(a)*ilambda.'*Id+intval(14)*Id;
                                 end
                             end
                         else
                             Jabij=zeros(2*m-1);
                         end
                         
                         if i==4 && j==1  %nonlinear part
                             if prod(a-b>=0)==1
                             A2=compute_quad_int([1,1],a-b,alphas);
                             Jabij=Jabij+i3*tildeMat(A2);
                             end
                         end
                         Jab((i-1)*(2*m-1)+1:i*(2*m-1),(j-1)*(2*m-1)+1:j*(2*m-1))=Jabij;
%       
            
                      end
                   end
                    Ja(:,4*(2*m-1)*cont+[1:4*(2*m-1)])=Jab;
                   cont=cont+1;
             
   
            end
        end
           Jacobian(cont2*4*(2*m-1)+[1:4*(2*m-1)],:)=Ja;
     
        cont2=cont2+1;
    end
end

  
                




end

%%


function  S=compute_cubic(J,n,alphas)
            dim_man=length(n); 
            J(J==0)=[];
            vecs= struct('comp', {}) ;
            % all possible combination of length(J) elemnnts that sums up to n(d) 
            for d=1:length(n)
                PRd = perms_rep(n(d)+1,length(J)) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
                PRd = PRd-1; 
                PRd(sum(PRd,2)~=n(d),:)=[];
                vecs(d).comp=PRd;
            end
           
             for l=1:length(n)
                 dimcomp(l)=size(vecs(l).comp,1);
             end
             if length(n)==1
                  ALP(:,1)=[1:dimcomp(1)].';
             else
            ALP(:,1)=repmat([1:dimcomp(1)].',dimcomp(2),1);
            ALP(:,2)=kron([1:dimcomp(2)].',ones(dimcomp(1),1));
            for l=3:length(n)
                ALP=repmat(ALP,dimcomp(l),1);
                ALP=[ALP,kron([1:dimcomp(l)].',ones(ALP,1))];
               
            end
             end
            M_comp=prod(dimcomp);
           Alphasj=zeros(length(J),length(n),M_comp);
           for ii=1:M_comp
               for jj=1:length(n)
               Alphasj(:,jj,ii)=(vecs(jj).comp(ALP(ii,jj),:)).';
               end
           end

            S=0;
            for ii=1:size(Alphasj,3)
                v1=Alphasj(1,:,ii);
                position1=num2cell(v1+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=al1(J(1),:);
                Conv=al1;
                for jj=2:size(Alphasj,1)
                    vj=Alphasj(jj,:,ii);
                    positionj=num2cell(vj+ones(1,dim_man));
                    alj=getfield(alphas,positionj,'fc');
                    alj=alj(J(jj),:);
                    Conv=quadratic_sum_complex(Conv.',alj.').';
                end
                S=S+Conv;
            end
end
        
%%%%%%


function  S=compute_cubic_int(J,n,alphas)
            i0=intval('0');

            m=(size(alphas(1,2).fc,2)+1)/2;
            dim_man=length(n); 
            J(J==0)=[];
            vecs= struct('comp', {}) ;
            % all possible combination of length(J) elemnnts that sums up to n(d) 
            for d=1:length(n)
                PRd = perms_rep(n(d)+1,length(J)) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
                PRd = PRd-1; 
                PRd(sum(PRd,2)~=n(d),:)=[];
                vecs(d).comp=PRd;
            end
           
             for l=1:length(n)
                 dimcomp(l)=size(vecs(l).comp,1);
             end
             if length(n)==1
                  ALP(:,1)=[1:dimcomp(1)].';
             else
            ALP(:,1)=repmat([1:dimcomp(1)].',dimcomp(2),1);
            ALP(:,2)=kron([1:dimcomp(2)].',ones(dimcomp(1),1));
            for l=3:length(n)
                ALP=repmat(ALP,dimcomp(l),1);
                ALP=[ALP,kron([1:dimcomp(l)].',ones(ALP,1))];
               
            end
             end
            M_comp=prod(dimcomp);
           Alphasj=zeros(length(J),length(n),M_comp);
           for ii=1:M_comp
               for jj=1:length(n)
               Alphasj(:,jj,ii)=(vecs(jj).comp(ALP(ii,jj),:)).';
               end
           end
%       
           
            S=i0;
            for ii=1:size(Alphasj,3)
                v1=Alphasj(1,:,ii);
                position1=num2cell(v1+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=intval(al1(J(1),:));
                
                Conv=al1;
                for jj=2:size(Alphasj,1)
                    vj=Alphasj(jj,:,ii);
                    positionj=num2cell(vj+ones(1,dim_man));
                    alj=getfield(alphas,positionj,'fc');
                    alj=intval(alj(J(jj),:));
                    alj=[intval(zeros(1,(jj-1)*(m-1))),alj,intval(zeros(1,(jj-1)*(m-1)))];
                    Conv=[intval(zeros(1,m-1)),Conv,intval(zeros(1,m-1))];
                    Conv=quadratic_sumFFT_complex_int(Conv.',alj.').';
                end
                S=S+Conv;
            end
end
        
%%%%%
function  S=compute_quad(J,n,alphas)
            dim_man=length(n); 
            J(J==0)=[];
            vecs= struct('comp', {}) ;
            % all possible combination of length(J) elemnnts that sums up to n(d) 
            for d=1:length(n)
                PRd = perms_rep(n(d)+1,length(J)) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
                PRd = PRd-1; 
                PRd(sum(PRd,2)~=n(d),:)=[];
                vecs(d).comp=PRd;
            end
           
             for l=1:length(n)
                 dimcomp(l)=size(vecs(l).comp,1);
             end
             if length(n)==1
                  ALP(:,1)=[1:dimcomp(1)].';
             else
            ALP(:,1)=repmat([1:dimcomp(1)].',dimcomp(2),1);
            ALP(:,2)=kron([1:dimcomp(2)].',ones(dimcomp(1),1));
            for l=3:length(n)
                ALP=repmat(ALP,dimcomp(l),1);
                ALP=[ALP,kron([1:dimcomp(l)].',ones(ALP,1))];
             
            end
             end
            M_comp=prod(dimcomp);
           Alphasj=zeros(length(J),length(n),M_comp);
           for ii=1:M_comp
               for jj=1:length(n)
               Alphasj(:,jj,ii)=(vecs(jj).comp(ALP(ii,jj),:)).';
               end
           end
%       
           
            S=0;
            for ii=1:size(Alphasj,3)
                v1=Alphasj(1,:,ii);
                position1=num2cell(v1+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=al1(J(1),:);
                Conv=al1;
                for jj=2:size(Alphasj,1)
                    vj=Alphasj(jj,:,ii);
                    positionj=num2cell(vj+ones(1,dim_man));
                    alj=getfield(alphas,positionj,'fc');
                    alj=alj(J(jj),:);
                    Conv=quadratic_sum_complex(Conv.',alj.').';
                end
                S=S+Conv;
            end
        end
              
%%%%%%

function  S=compute_quad_int(J,n,alphas)
            dim_man=length(n); 
            J(J==0)=[];
            vecs= struct('comp', {}) ;
            % all possible combination of length(J) elemnnts that sums up to n(d) 
            for d=1:length(n)
                PRd = perms_rep(n(d)+1,length(J)) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
                PRd = PRd-1; 
                PRd(sum(PRd,2)~=n(d),:)=[];
                vecs(d).comp=PRd;
            end
           
             for l=1:length(n)
                 dimcomp(l)=size(vecs(l).comp,1);
             end
             if length(n)==1
                  ALP(:,1)=[1:dimcomp(1)].';
             else
            ALP(:,1)=repmat([1:dimcomp(1)].',dimcomp(2),1);
            ALP(:,2)=kron([1:dimcomp(2)].',ones(dimcomp(1),1));
            for l=3:length(n)
                ALP=repmat(ALP,dimcomp(l),1);
                ALP=[ALP,kron([1:dimcomp(l)].',ones(ALP,1))];
             ;
            end
             end
            M_comp=prod(dimcomp);
           Alphasj=zeros(length(J),length(n),M_comp);
           for ii=1:M_comp
               for jj=1:length(n)
               Alphasj(:,jj,ii)=(vecs(jj).comp(ALP(ii,jj),:)).';
               end
           end

           
            S=intval(0);
            for ii=1:size(Alphasj,3)
                v1=Alphasj(1,:,ii);
                position1=num2cell(v1+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=intval(al1(J(1),:));
                Conv=al1;
                for jj=2:size(Alphasj,1)
                    vj=Alphasj(jj,:,ii);
                    positionj=num2cell(vj+ones(1,dim_man));
                    alj=getfield(alphas,positionj,'fc');
                    alj=intval(alj(J(jj),:));
                    Conv=quadratic_sumFFT_complex_int(Conv.',alj.').';
                end
                S=S+Conv;
            end
        end
              






% function [s]=quadratic_sumFFT_complex(c1,c2)
% if size(c1,2)>1
%     c1=c1.';
% end
% if size(c2,2)>1
%     c2=c2.';
% end
% m=(length(c1)+1)/2;
% 
% ta1=[zeros(m,1);c1;zeros(m,1)];
% tu1=ifft(ifftshift(ta1));
% 
% ta2=[zeros(m,1);c2;zeros(m,1)];
% tu2=ifft(ifftshift(ta2));
% 
% F=fftshift(fft(tu1.*tu2));
% 
% s=(4*m-1)*F(m+1:3*m-1);
% 
% end
function tildeA=tildeMat(a)
m=(length(a)+1)/2;
if  isa(a,'intval')
a=[intval(zeros(1,m-1)),a,intval(zeros(1,m-1))];
else
    a=[zeros(1,m-1),a,zeros(1,m-1)];
end
center=2*m-1;

if  isa(a,'intval')
tildeA=intval(zeros(2*m-1));    
else
tildeA=zeros(2*m-1);
end

for N=-m+1:m-1
   tildeA(m+N,:)=a(center+N-[-m+1:1:m-1]); 
end

end


function tildeA=tildeA(k,c,alphas)
if c<0
    tildeA=0;
    return
end
a=alphas(c+1).fc(k,:);
m=(length(a)+1)/2;

a=[zeros(1,m-1),a,zeros(1,m-1)];
center=2*m-1;
tildeA=zeros(2*m-1);
for N=-m+1:m-1
   tildeA(m+N,:)=a(center+N-[-m+1:1:m-1]); 
end
end


function [s]=quadratic_sumFFT_complex_int(a1,a2)


i2=intval('2');
i4=intval('4');

if size(a1,2)>1
    a1=a1.';
end
if size(a2,2)>1
    a2=a2.';
end
M=(length(a1)+1)/2;



% We make sure that the inputs are powers of 2 %
M1=(2^ceil(log(4*M-1)/log(2))-4*M)/2;   % Hence 4*M+2*M1 is a power of 2 %
ta1=[intval(zeros(M+M1+1,1));a1;intval(zeros(M+M1,1))];
ta2=[intval(zeros(M+M1+1,1));a2;intval(zeros(M+M1,1))];
tu1=verifyfft(ifftshift(ta1),-1);
tu2=verifyfft(ifftshift(ta2),-1);
F=fftshift(verifyfft(tu1.*tu2,1));
s=(i4*intval(M)+i2*intval(M1))*F(M1+M+2:M1+3*M,1);
end
