function [alphas,lambda]=high_order_coefficients_bridge(gamma,T,Q,R,m,N,stability,D2,dim_man,scaleEigs,Qinv,rf)
% OUTPUTS
alphas= struct('n', {}, 'fc', {}) ;
%alphas(k).n =n alphas(k).fc= Fourier coefficients of a^n
%for (a^n)_k with k=-(m-1)..(m-1) and |n|=0...N

cd Floquet_multipliers
if stability=='S'
load x3
lambda(1)=x3(1);
v_1=reshape(x3(2:end),[],4).';
S=size(v_1);
v1_2T=zeros(S(1),(S(2)-1)*2+1);
v1_2T(:,1:2:end)=v_1;    % move to 2T-periodic function
v1_2T=v1_2T/norm(sum(v1_2T,2));
load x4
lambda(2)=x4(1);
v_2=reshape(x4(2:end),[],4).';
S=size(v_2);
v2_2T=zeros(S(1),(S(2)-1)*2+1);
v2_2T(:,1:2:end)=v_2;
v2_2T=v2_2T/norm(sum(v2_2T,2));
v=cat(3,v1_2T,v2_2T);
else
    load x2
lambda(1)=x2(1);
v_1=reshape(x2(2:end),[],4).';
S=size(v_1);
v1_2T=zeros(S(1),(S(2)-1)*2+1);
v1_2T(:,1:2:end)=v_1;
v=v1_2T;
end
if size(v,3)~=dim_man
    'warning: manifold dimension does not agree with number of eigenvalues'
    dim_man=size(v,3);
end

cd ..
[M,Sigma]=eig(R);
v(:,:,1)=scaleEigs(1)*v(:,:,1);
v(:,:,2)=scaleEigs(2)*v(:,:,2);
Minv=inv(M);


mv=(size(v,2)+1)/2;
if m>mv
v=cat(2,zeros(size(v,1),m-mv,size(v,3)),v,zeros(size(v,1),m-mv,size(v,3)));
end


mQ=(size(Q,3)+1)/2; %Pk k=-mP+1....mP-1   P(:,:,mP+1)=P_0
mQinv=(size(Qinv,3)+1)/2;
mgamma=(size(gamma,2)+1)/2;
dimN=size(Q,1);  %dimension of the vector field

if mQ<2*m
    diff=2*m-mQ;
    Q=cat(3,zeros(size(Q,1),size(Q,2),diff),Q,zeros(size(Q,1),size(Q,2),diff));
    mQ=(size(Q,3)+1)/2;
end
if  mgamma<m
    diff=m-mgamma;
    gamma=[zeros(size(gamma,1),diff),gamma,zeros(size(gamma,1),diff)];
    mgamma=(size(gamma,2)+1)/2;
end
Qcell=mat2cell(reshape(Q,dimN,[]),dimN,dimN*ones(1,2*mQ-1));
Qinvcell=mat2cell(reshape(Qinv,dimN,[]),dimN,dimN*ones(1,2*mQinv-1));

Z=zeros(1,dim_man);
% n=(0,...0)

alphas(1,1).n=Z;
alphas(1,1).fc=gamma(:,mgamma+[-(m-1):1:(m-1)]);

% |n|=1
for j_man=1:dim_man
    n=Z;
    n(j_man)=1;
    position=num2cell(n+1);
    alphas=setfield(alphas,position,'n',n);
    alphas=setfield(alphas,position,'fc',v(:,:,j_man));
end

% |n|>1
% define all the multiindexes
PR = perms_rep(N+1,dim_man) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
PR = PR-1;                            %let the values go from 0 to NMAX
PR = [PR,sum(PR,2)];                  %compute the norm of the rows
PR(PR(:,end)>N,:)=[];
PR = sortrows(PR,dim_man+1);


Qinvcell=[repmat(mat2cell(zeros(dimN)),1,2*m-mQinv),Qinvcell,repmat(mat2cell(zeros(dimN)),1,2*m-mQinv)];
mQinvcell=(size(Qinvcell,2)+1)/2;
Qcell=[repmat(mat2cell(zeros(dimN)),1,2*m-mQ),Qcell,repmat(mat2cell(zeros(dimN)),1,2*m-mQ)];
mQcell=(size(Qcell,2)+1)/2;
Qinv_conv=cell((2*m-1));
Q_conv=cell(2*m-1);
for k=-(m-1):(m-1)
    k2=k-[-(m-1):(m-1)];
    Qinv_conv(m+k,:)=Qinvcell(mQinvcell+k2);    
    Q_conv(m+k,:)=Qcell(mQcell+k2);
end
Qinv_conv=cell2mat(Qinv_conv);
Q_conv=cell2mat(Q_conv);
for modn=2:N
    vectors_modn=PR(PR(:,end)==modn,1:end-1);   % select the multiindices with norm modN
    for j_modn=1:size(vectors_modn,1)
        n=vectors_modn(j_modn,:);
        Ra=compute_Rt;
        A_a=reshape(Qinv_conv*reshape(Ra,[],1),4,[]);
        
        v_a=(repmat(2*pi*1i*[-(m-1):m-1]/(T)+sum(n.*lambda),4,1)-repmat(diag(Sigma),1,2*m-1)).^(-1).*( Minv*A_a);
      
        a_a=reshape(Q_conv*reshape(M*v_a,[],1),4,[]);
        
        alphas=setfield(alphas,num2cell(n+1),'n',n);       
        alphas=setfield(alphas,num2cell(n+1),'fc',a_a);
        
    end
    
end
 function Rt=compute_Rt
        
        Rt=zeros(dimN,2*m-1);
        for D=1:size(D2,3)  
            d2=D2(:,:,D);
            for j=1:size(d2,1)
                if d2(j,1)~=0
                    Sj=non_linear_t(d2(j,2:end));
                    Rt(j,:)=Rt(j,:)+d2(j,1)*Sj;
                end
                
            end
        end
        function  S=non_linear_t(J)
            J(J==0)=[];
            vecs= struct('comp', {}) ;
            % all possible combnation of length(J) elemnnts that sums up to n(d) 
            for d=1:length(n)
                PRd = perms_rep(n(d)+1,length(J)) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
                PRd = PRd-1; 
                PRd(sum(PRd,2)~=n(d),:)=[];
                vecs(d).comp=PRd;
            end
           
             for l=1:length(n)
                 dimcomp(l)=size(vecs(l).comp,1);
             end
             if length(n)==1
                  ALP(:,1)=[1:dimcomp(1)].';
             else
            ALP(:,1)=repmat([1:dimcomp(1)].',dimcomp(2),1);
            ALP(:,2)=kron([1:dimcomp(2)].',ones(dimcomp(1),1));
            for l=3:length(n)
                ALP=repmat(ALP,dimcomp(l),1);
                ALP=[ALP,kron([1:dimcomp(l)].',ones(ALP,1))];
              
            end
             end
            M_comp=prod(dimcomp);
           Alphasj=zeros(length(J),length(n),M_comp);
           for ii=1:M_comp
               for jj=1:length(n)
               Alphasj(:,jj,ii)=(vecs(jj).comp(ALP(ii,jj),:)).';
               end
           end
           remove=[];
           for ii=1:M_comp
               ceck=sum(sum(Alphasj(:,:,ii)==repmat(n,length(J),1),2)==length(n));
               if ceck>0
                   remove=[remove,ii];
               end
           end
           Alphasj(:,:,remove)=[];
           
            S=0;
            for ii=1:size(Alphasj,3)
                v1=Alphasj(1,:,ii);
                position1=num2cell(v1+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=al1(J(1),:);
                Conv=al1;
                for jj=2:size(Alphasj,1)
                    vj=Alphasj(jj,:,ii);
                    positionj=num2cell(vj+ones(1,dim_man));
                    alj=getfield(alphas,positionj,'fc');
                    alj=alj(J(jj),:);
                    Conv=quadratic_sum_complex(Conv.',alj.').';
                end
                mConv=(length(Conv)+1)/2;
                S=S+Conv(mConv+[-m+1:m-1]);
            end
        end
        
 end



end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


