function [R,Q,JJ]=newton_floquet_bridge2T(Q,R,Ak,T)

%Newton scheme for the solution of Q^{-1}


 m=(size(Q,3)+1)/2;
 Ak=cat(3,zeros(4,4,2*m),Ak,zeros(4,4,2*m));

F=map_floquet(Ak,Q,R,T);

Ntest=0;
X=reshape(cat(3,Q(:,:,1:m-1),R,Q(:,:,m:end)),[],1);

disp('norm(F,inf)');
while norm(F,inf)>9*1e-14  

JJ=  jacobian_floquet_bridge_nosym(R,Q,Ak,2*T);
X1=X-JJ\F;
Q=cat(3,reshape(X1(1:(m-1)*16),4,4,m-1),reshape(X1(16*m+1:end),4,4,m));
R=reshape(X1((m-1)*16+1:m*16),4,4,1);

    F=map_floquet(Ak,Q,R,T);

   display(['Inf-norm of F(x) = ',num2str( norm(F,inf))])

    Ntest=Ntest+1;
    if Ntest>5
        if norm(F,inf)<5*1e-13
            break
        elseif norm(F,inf)>1
            disp('Newton scheme for the Floquet system does not converge');
            disp('Try to change  m');
            R=[];
            Q=[];
            return
        else
            Ntest=Ntest-2;
        end
    end
  X=reshape(cat(3,Q(:,:,1:m-1),R,Q(:,:,m:end)),[],1);      
end
JJ=  jacobian_floquet_bridge_nosym(R,Q,Ak,2*T);



%%%%%%%%%%%%%%%
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
end
%%%%%%

function F=map_floquet(Ak,Q,R,T)
        m=(size(Q,3)+1)/2;
        dim=size(R,1);
        F=zeros(dim,dim,2*(m-1)+1+1);
        for k=-(m-1):-1
           F(:,:,m+k)=1i*k*pi/T*Q(:,:,m+k)+Q(:,:,m+k)*R-convAQ(k,Ak,Q) ;
        end
          F(:,:,m)=sum(Q,3)-eye(dim);
          for k=0:m-1
               F(:,:,m+1+k)=1i*k*pi/T*Q(:,:,m+k)+Q(:,:,m+k)*R-convAQ(k,Ak,Q) ;
          end
          
          F=reshape(F,[],1);
end
    function Conv=convAQ(k,A,Q)
        medA=(size(A,3)+1)/2;
        m=(size(Q,3)+1)/2;
        Conv=zeros(4);
        for l=-(m-1):m-1
            j=k-l;
           Conv=Conv+A(:,:,medA+j)*Q(:,:,m+l);
        end
    end
