function Par=plot_parametrization_complex(T,a,Sigma)


% a is the structure of the parametrization
% a.n   a(n).fc Fourier coefficient of a^(n-1)(t) on the tau periodic basis
% n=1....N


S=size(a(1).fc);

m=(S(2)-1)/2;  %number of Four. coefficients for any a_n
dimN=S(1);

N=size(a,2)-1;

thetas=linspace(0,T/2,400);
%sigma=1


     

% fourier coefficients of the periodic orbit
gamma_k=a(1).fc;   

% orbit in time space
gamma=zeros(dimN,length(thetas));
for k=-m:m
    expk=exp(1i*k*2*pi/T*thetas);
    gamma=gamma+gamma_k(:,m+1+k)*expk;
    
end
if max(max(imag(gamma)))<10^-14
    gamma=real(gamma);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

an=[];
norm_an=[];
for j=1:N                   % each aj(t) in time space (theta space)
    an_k=a(j+1).fc;          
    a_ntheta=zeros(dimN,length(thetas));
    for k=-m:m
        expk=exp(1i*k*2*pi/T*thetas);
        a_ntheta=a_ntheta+an_k(:,m+1+k)*expk;
    end
    an=cat(3,an,a_ntheta);
  %  norm_an=[norm_an,(max(sum(a_ntheta.^2,1).^(1/2)))^(1/j)];
end
%Sigma=min(1./real(norm_an(3:end)));
%Sigma=1.65;
%sigma=[-1,0,6]
sigma=linspace(-Sigma,Sigma,20); %need to do both + and -
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%


Par=[];                    % Parametrization
for st=1:length(sigma)     % steps of sigma
    sigmast=sigma(st);
    par=gamma;
    for j=1:N
        par=par+an(:,:,j)*sigmast^j;
    end
    Par=cat(3,Par,par);
end

Par=real(Par);


f1=figure(1);
hold on
cmap=colormap(autumn(size(Par,3)));
%cmap=colormap(winter(size(Par,3)));
%cmap=colormap(cool(size(Par,3)));

for j=1:size(Par,3)-1
for i=1:size(Par,2)-1
    V=[Par(:,i,j)'; Par(:,i+1,j)';Par(:,i+1,j+1)'; Par(:,i,j+1)'];
    Fac=[1,2,3,4];
hold on
patch('vertices',V,'faces',Fac,'facecolor',cmap(j,:),'Edgecolor','none','FaceAlpha',0.8,'EdgeAlpha',0.8);%,'FaceLighting','phong');
   
%patch('vertices',V,'faces',Fac,'facecolor',cmap(j,:),'Edgecolor',cmap(j,:),'FaceAlpha',0.7);%,'FaceLighting','phong');
%patch('vertices',V,'faces',Fac,'facecolor','b','Edgecolor','b','FaceAlpha',0.5);
end
end
axis equal
%set(findobj(gca,'type','surface'),'FaceLighting','phong',...
 %      'AmbientStrength',.3,'DiffuseStrength',.8,'SpecularStrength',.9,...
 %      'SpecularExponent',25,'BackFaceLighting','unlit')
 %   light('Position',[10 10.31 20.1],'Style','infinite');
    xlabel('x')
    ylabel('y')
    zlabel('z');
%title(['\sigma in  [' num2str([sigma(1), sigma(end)],3) ']'])

%light('Position',[0 0 0],'Style','local','color',[1,0,1]);
plot3(gamma(1,:),gamma(2,:),gamma(3,:),'k','Linewidth',1);
axis equal
axis tight
%close(f2)
% figure(2)
% 
%f3=figure(3)
% cmap=colormap(autumn(size(Par,3)));
% cmap=colormap(winter(size(Par,3)));
% 
% for j=1:size(Par,3)
%      plot3(Par(1,:,j),Par(2,:,j),Par(3,:,j),'color',cmap(j,:));
%      
%      %plot3(Par(1,:,j),Par(2,:,j),Par(3,:,j),'b');
%      hold on
% end

%plot3(gamma(1,:),gamma(2,:),gamma(3,:),'k','Linewidth',2);
%axis equal
% 
% figure(3)
% cmap=colormap(autumn(size(Par,3)));
% for j=1:size(Par,3)
%      plot(thetas,Par(1,:,j),'color',cmap(j,:));
%      
%     
%      hold on
% end
% plot(thetas, gamma(1,:),'k','Linewidth',2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


