



u0=[x0;y0;z0];

options = odeset('RelTol',1e-8,'AbsTol',1e-10);

[t,y]=ode45(@lorenz_classic,[0 T],u0,options,rho);   


% First approach based on computing the integrals %

m=m_gamma; % # of Fourier coefficients we keep
omega=2*pi/T;
i=sqrt(-1);

a1=zeros(2*m-1,1);
a2=zeros(2*m-1,1);
a3=zeros(2*m-1,1);

for k=-m+1:-1
    v=exp(-i*k*omega*t(2:end))-exp(-i*k*omega*t(1:end-1));
    a1(k+m)=-1/(2*pi*k*i)*sum(y(1:end-1,1).*v);
    a2(k+m)=-1/(2*pi*k*i)*sum(y(1:end-1,2).*v);
    a3(k+m)=-1/(2*pi*k*i)*sum(y(1:end-1,3).*v);
end

a1(m)=omega/(2*pi)*sum(y(1:end-1,1).*(t(2:end)-t(1:end-1)));
a2(m)=omega/(2*pi)*sum(y(1:end-1,2).*(t(2:end)-t(1:end-1)));
a3(m)=omega/(2*pi)*sum(y(1:end-1,3).*(t(2:end)-t(1:end-1)));

for k=1:m-1
    v=exp(-i*k*omega*t(2:end))-exp(-i*k*omega*t(1:end-1));
    a1(k+m)=-1/(2*pi*k*i)*sum(y(1:end-1,1).*v);
    a2(k+m)=-1/(2*pi*k*i)*sum(y(1:end-1,2).*v);
    a3(k+m)=-1/(2*pi*k*i)*sum(y(1:end-1,3).*v);
end

gamma0_phase_bar=u0;
gamma0_phase_dot=lorenz_classic(1,u0,rho)/norm(lorenz_classic(1,u0,rho));

gamma0_phase(:,1)=gamma0_phase_bar;
gamma0_phase(:,2)=gamma0_phase_dot;

clear gamma0_phase_bar gamma0_phase_dot y t

sigma=10;  
beta=8/3;

par=[sigma;rho;beta];

k0=10; % # of Fourier coefficients kept for the phase condition

clear w1 w2 w3 m options T x0 y0 z0 u0 

x=[omega;a1;a2;a3];



clear  a1 a2 a3 i k omega v

[x]=newton_f_comp_lorenz(x,gamma0_phase,par,k0);

while norm(x(end-4:end))>1e-13;
    [x]=padding_lorenz_comp(x,10);
    [x]=newton_f_comp_lorenz(x,gamma0_phase,par,k0);
end

x(1)=real(x(1));
    

[r,success,Ranalytic]=rad_poly_analytic_lorenz(x,gamma0_phase,par,k0,nu_gamma);

if success==1
    plot_periodic_complex(x)
end
clear m