function [alphas,lambda,v,r_v]=high_order_coefficients(gamma,T,Q,R,m,N,stability,D2,dim_man,scaleEigs,Qinv,rf)
% OUTPUTS
alphas= struct('n', {}, 'fc', {}) ;
%alphas(k).n =n alphas(k).fc= Fourier coefficients of a^n
%for (a^n)_k with k=-(m-1)..(m-1) and |n|=0...N



[V,Lambda]=eig(R);
Sigma=Lambda;
M=V;
Minv=inv(V);
Lambda=diag(Lambda);
[~,w]=min(abs(Lambda));
Lambda(w)=[]; V(:,w)=[];
ST=find(real(Lambda)<0);
UNST=find(real(Lambda)>0);
%select lambda and v according with the stability of the wanted manifold
if stability=='S'
    [~,w]=sort(abs(Lambda(ST)));
    if isempty(ST)==1
        disp('The orbit is fully unstable, please change the stability to "U"');
        alphas=[];
        return
    end
    lambda=Lambda(ST(w(1:dim_man)));
    v=V(:,ST(w(1:dim_man)));
    
else
    [~,w]=sort(abs(Lambda(UNST)));
    if isempty(UNST)==1
        disp('The orbit is fully stable, please change the stability to "S"');
        alphas=[];
        lambda='Nan'
        return
    end
        lambda=Lambda(UNST(w(1:dim_man)));
    v=V(:,UNST(w(1:dim_man)));
end

r_v=enc_eig(midrad(R,rf),v,lambda);

mQ=(size(Q,3)+1)/2; %Pk k=-mP+1....mP-1   P(:,:,mP+1)=P_0
mQinv=(size(Qinv,3)+1)/2;
mgamma=(size(gamma,2)+1)/2;
dimN=size(gamma,1);  %dimension of the vector field

if mQ<2*m
    diff=2*m-mQ;
    Q=cat(3,zeros(size(Q,1),size(Q,2),diff),Q,zeros(size(Q,1),size(Q,2),diff));
    mQ=(size(Q,3)+1)/2;
end
if  mgamma<m
    diff=m-mgamma;
    gamma=[zeros(size(gamma,1),diff),gamma,zeros(size(gamma,1),diff)];
    mgamma=(size(gamma,2)+1)/2;
end
Qcell=mat2cell(reshape(Q,3,[]),3,3*ones(1,2*mQ-1));
Qinvcell=mat2cell(reshape(Qinv,3,[]),3,3*ones(1,2*mQinv-1));

Z=zeros(1,dim_man);
% n=(0,...0)

alphas(1,1).n=Z;
alphas(1,1).fc=gamma(:,mgamma-(m-1):mgamma+m-1);

% |n|=1
for jj=1:dim_man
    n=Z;
    n(jj)=1;
    position=num2cell(n+1);
    alphas=setfield(alphas,position,'n',n);
    l=-(m-1):m-1;
    FC=cellfun(@(x) x*scaleEigs(jj)*v(:,jj),Qcell(mQ+l),'UniformOutput',false);%Q(:,:,mQ+l)*scaleEigs(jj)*v(:,jj)
    alphas=setfield(alphas,position,'fc',cell2mat(FC));
end

% |n|>1
% define all the multiindexes
PR = perms_rep(N+1,dim_man) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
PR = PR-1;                            %let the values go from 0 to NMAX
PR = [PR,sum(PR,2)];                  %compute the norm of the rows
PR(PR(:,end)>N,:)=[];
PR = sortrows(PR,dim_man+1);


Qinvcell=[repmat(mat2cell(zeros(3)),1,2*m-mQinv),Qinvcell,repmat(mat2cell(zeros(3)),1,2*m-mQinv)];
mQinvcell=(size(Qinvcell,2)+1)/2;
Qcell=[repmat(mat2cell(zeros(3)),1,2*m-mQ),Qcell,repmat(mat2cell(zeros(3)),1,2*m-mQ)];
mQcell=(size(Qcell,2)+1)/2;
Qinv_conv=cell((2*m-1));
Q_conv=cell(2*m-1);
for k=-(m-1):(m-1)
    k2=k-[-(m-1):(m-1)];
    Qinv_conv(m+k,:)=Qinvcell(mQinvcell+k2);    
    Q_conv(m+k,:)=Qcell(mQcell+k2);
end
Qinv_conv=cell2mat(Qinv_conv);
Q_conv=cell2mat(Q_conv);
for modn=2:N
    vectors_modn=PR(PR(:,end)==modn,1:end-1);   % select the multiindices with norm modN
    for jj=1:size(vectors_modn,1)
        n=vectors_modn(jj,:);
        Ra=compute_Rt;
        A_a=reshape(Qinv_conv*reshape(Ra,[],1),3,[]);
        
        v_a=(repmat(2*pi*1i*[-(m-1):m-1]/(T)+sum(n.*lambda),3,1)-repmat(diag(Sigma),1,2*m-1)).^(-1).*( Minv*A_a);
        
        a_a=reshape(Q_conv*reshape(M*v_a,[],1),3,[]);
        
        alphas=setfield(alphas,num2cell(n+1),'n',n);       
        alphas=setfield(alphas,num2cell(n+1),'fc',a_a);
        
    end
    
end
 function Rt=compute_Rt
        
        Rt=zeros(dimN,2*m-1);
        for D=1:size(D2,3)  
            d2=D2(:,:,D);
            for j=1:size(d2,1)
                if d2(j,1)~=0
                    Sj=non_linear_t(d2(j,2),d2(j,3));
                    Rt(j,:)=Rt(j,:)+d2(j,1)*Sj;
                end
                
            end
        end
        function  S=non_linear_t(j1,j2)
            %T=time(end);
            %
           % S=zeros(size(time));
            % we need to identify the couples k1,k2 : |k1|,|k2|>=1 and
            % k1+k2=n. It is enough to find all the possible k1 and then
            % k2=n-k1
            vectors_k1=PR((PR(:,end)<modn) & (PR(:,end)>0),1:end-1);           %select those j1=! 0 so that j1+j2=N
            N_minus_veck=ones(size(vectors_k1,1),1)*n-vectors_k1;
            vectors_k1=vectors_k1(min(N_minus_veck,[],2)>=0,:);
            S=zeros(1,2*m-1);
            for kk=1:size(vectors_k1,1)
                v1=vectors_k1(kk,:);
                v2=n-v1;
                position1=num2cell(v1+ones(1,dim_man));
                position2=num2cell(v2+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=al1(j1,:);
                al2=getfield(alphas,position2,'fc');
                al2=al2(j2,:);
             
                S=S+(quadratic_sum_complex(al1.',al2.')).';
                

            end
            
        end
        
 end



end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function PR = perms_rep(N,K)
% This is (basically) the same as npermutek found on the FEX.  It is the
% fastest way to calculate these (in MATLAB) that I know.
% pr = @(N,K) N^K;  Number of rows.
% A speed comparison could be made with COMBN.m, found on the FEX.  This
% is an excellent code which uses ndgrid.  
    

if N==1
    PR = ones(1,K,class(N));
    return
elseif K==1
    PR = (1:N).';
    return
end

CN = class(N);
M = double(N);  % Single will give us trouble on indexing.
L = M^K;  % This is the number of rows the outputs will have.
PR = zeros(L,K,CN);  % Preallocation.
D = ones(1,N-1,CN);  % Use this for cumsumming later.
LD = M-1;  % See comment on N.
VL = [-(N-1) D].';  % These values will be put into PR.
% Now start building the matrix.
TMP = VL(:,ones(L/M,1,CN));  % Instead of repmatting.
PR(:,K) = TMP(:);  % We don't need to do two these in loop.
PR(1:M^(K-1):L,1) = VL;  % The first column is the simplest.
% Here we have to build the cols of PR the rest of the way.
for ii = K-1:-1:2
    ROWS = 1:M^(ii-1):L;  % Indices into the rows for this col.
    TMP = VL(:,ones(length(ROWS)/(LD+1),1,CN));  % Match dimension.
    PR(ROWS,K-ii+1) = TMP(:);  % Build it up, insert values.
end

PR(1,:) = 1;  % For proper cumsumming.
PR = cumsum2(PR);  % This is the time hog.
end
function A = cumsum2(A)
%CUMSUM2, works with integer classes.
% Duplicates the action of cumsum, but for integer classes.
% If Matlab ever allows cumsum to work for integer classes, we can remove
% this.

if isfloat(A)
    A = cumsum(A);  % For single and double, use built-in.
    return
else
    try
        A = cumsumall(A);  % User has the MEX-File ready?
    catch
        warning('Cumsumming by loop.  MEX cumsumall.cpp for speed.') 
        for ii = 2:size(A,1)
            A(ii,:) = A(ii,:) + A(ii-1,:); % User likes it slow.
        end
    end
end
end