% compute high order parameterization of 1-dimensional manifolds for the
% Lorenz system and its enclosure in the analytical category
% as in paper
%% R.C, J.P. Lessard, J.D Mireles Parameterization of invariant manifolds for periodic
%  orbits (II): a-posteriori analysis and computer assisted error bounds

% This script reports the syntax to run the proofs reported into the paper
% Select a proper solution_number from 0 to 7

clear
close all

solution_number=1;  % from 0 to 7%


switch solution_number
    case 0
        rho=22; x0=-11.499620573254672; y0=-10.771557108506295; z0=26.613929559602696;  T=0.764386427426137; 
        m_gamma=40;
        nu_gamma=1.3;
        M=40;
        N=10;
        scaleEigs=1;
        stability='S';
        NU=1;
    case 1
        rho=17.32; x0=-11.778549922034278; y0=  -9.540901825919869; z0=  24.567464625979135; T=1.108418372682485;
        m_gamma=40;
        nu_gamma=1.6;
        M=40;
        N=6;
        scaleEigs=1;
        stability='S';
        NU=1;
        
    case 2
        rho=22; x0=-11.499620573254672; y0=-10.771557108506295; z0=26.613929559602696;  T=0.764386427426137; 
        m_gamma=40;
        nu_gamma=1.3;
        M=40;
        N=10;
        scaleEigs=1;
        stability='S';
        NU=2;
    case 3
        rho=22; x0=-11.499620573254672; y0=-10.771557108506295; z0=26.613929559602696;  T=0.764386427426137; 
        m_gamma=40;
        nu_gamma=1.3;
        M=40;
        N=10;
        scaleEigs=1;
        stability='S';
        NU=4;
    case 4
         rho=20;  x0=-11.902001286120162;  y0=-10.430596766487434; z0= 26.207537242173992;  T=0.876552253491940;
        m_gamma=40;
        nu_gamma=1.3;
        M=40;
        N=10;
        scaleEigs=1;
        stability='S';
        NU=1;
    case 5
        rho=28; x0=-13.763610682134; y0=-19.578751942452; z0=27; T=1.5586522107162;
        m_gamma=80;
        nu_gamma=1.1;
        M=40;
        N=10;
        scaleEigs=1;
        stability='S';
        NU=1;
    case 6
        rho=28; x0=-13.763610682134; y0=-19.578751942452; z0=27; T=1.5586522107162;
        m_gamma=80;
        nu_gamma=1.1;
        M=60;
        N=10;
        scaleEigs=1;
        stability='S';
        NU=1.2;
    case 7
        rho=28; x0=-13.763610682134; y0=-19.578751942452; z0=27; T=1.5586522107162;
        m_gamma=80;
        nu_gamma=1.1;
        M=60;
        N=70;
        scaleEigs=2;
        stability='U';
        NU=1;
end
Main_High_order_par