function [r,alphas]=proof_high_order_terms_lorenz(f_int,Jac, Jac_int,lambda,T,par,par2,nu, alphas, Epsilon_norm)

i0=intval(0);
i1=intval(1);
i2=intval(2);
ipi=intval('pi');
inu=intval(nu);

rho=par(2);
sigma=par(1);
beta=par(3);
%par2=[m,space_dim, man_dim,N_manifold];
m=par2(1);
N=par2(4);

ilambda=lambda;
iT=intval(T);
twoipi2t=ipi*1i/(iT);
twoipim2t=twoipi2t*intval(m);


indeces=[reshape(repmat([2:N],3,1),1,[]);repmat([1,2,3],1,N-1)];
N_ind=length(indeces);

for al=1:length(alphas)
  alphas(al).norm=norm_nu(alphas(al).fc,nu); 
end

eps0=Epsilon_norm(:,1);    %%% r_0
eps1=Epsilon_norm(:,2);    %%% r_1

f_int_components=reshape(f_int,[],3*(N-1));
f_components_negk=f_int_components(1:m-1,:);
f_int_m=reshape(f_int_components(m:3*m-2,:),[],1);
f_components_posk=f_int_components(3*m-1:end,:);
Am=inv(Jac);
Amcell=mat2cell(Am,(2*m-1)*ones(1,N_ind),(2*m-1)*ones(1,N_ind));

% symmetrize A and compute dual norms
A_oper_norm=zeros(N_ind);
Nu_m=repmat(inu.^intval(abs(-m+1:1:m-1)).',1,2*m-1);
InvNu_m=inu.^intval(-abs(-m+1:1:m-1));
for q=1:N_ind
    for s=1:N_ind    
        MatA=Amcell{q,s};
        MatA(m,m)=real(MatA(m,m));
        MatA(m,1:m-1)=flip(conj(MatA(m,m+1:end)),2);
        MatA(m+1:end,:)=flip(flip(conj(MatA(1:m-1,:)),2),1);
        Amcell{q,s}=MatA;
       

        K=sum(abs(intval(MatA)).*Nu_m,1);
        normMatA=max(sup(K.*InvNu_m));
       
        if q==s
            q_al=indeces(1,q);
            normMatA=max([normMatA,sup((twoipim2t+intval(q_al)*ilambda)^(-i1))]);
        end
        A_oper_norm(q,s)=normMatA;
    end
end
Am=cell2mat(Amcell);
% bound Y=A*f(x)

Y_m=intval(Am)*f_int_m;
Y_m=reshape(Y_m,[],3*(N-1));


seq=1;  % move along the main diagonal of A
for a=2:N
    ia=intval(a);
    
    Y_negk=repmat(((twoipi2t*intval([-2*m+2:-m])+ia*ilambda).^(-i1)).',1,3).*f_components_negk(:,seq:seq+2);
    Y_posk=repmat(((twoipi2t*intval([m:2*m-2])+ia*ilambda).^(-i1)).',1,3).*f_components_posk(:,seq:seq+2);
    
    Y(seq:seq+2)=norm_nu([Y_negk;Y_m(:,seq:seq+2);Y_posk].',nu);
    seq=seq+3;

end
epsilon_F=intval(zeros(N_ind,1));

for a=2:N
   
     epsilon_F(3*(a-2)+1:3*(a-1))=[i0;...
         eps0(1)*alphas(a+1).norm(3)+eps0(3)*alphas(a+1).norm(1)+eps1(1)*alphas(a).norm(3)+eps1(3)*alphas(a).norm(1);...
         eps0(1)*alphas(a+1).norm(2)+eps0(1)*alphas(a+1).norm(1)+eps1(1)*alphas(a).norm(2)+eps1(2)*alphas(a).norm(1)];
    
   end
epsilon_F(2)=epsilon_F(2)+eps1(1)*eps1(3);
epsilon_F(3)=epsilon_F(3)+eps1(1)*eps1(2);
Y=Y+(intval(A_oper_norm)*epsilon_F).';

display(['max of Y = ',num2str( norm(Y.sup,inf))])
% bound Z(r)

%Z0=|(I-A^mA)c|

B=intval(eye(size(Am)))-intval(Am)*Jac_int; 
Bcell=mat2cell(B,(2*m-1)*ones(1,N_ind),(2*m-1)*ones(1,N_ind));
normB=cellfun(@(x) norm_dual(x,nu),Bcell);
Z0=sum(normB,2);

epsAdaga=[i0;eps0(1)+eps0(3);eps0(1)+eps0(2);repmat([i0;eps0(1)+eps0(3)+eps1(1)+eps1(3);eps0(1)+eps0(2)+eps1(1)+eps1(2)],N-2,1)];
Z0=Z0+(intval(A_oper_norm)*epsAdaga);

display(['max of Z0 = ',num2str( norm(Z0.sup,inf))])
%%%% bound Z1

tildeAcell=tildeAcellfun(alphas);
Gammacell=fungammacell(tildeAcell,N,3,m,sigma,rho,beta); % more precisely these re the matrices E
[addeps0,addeps1]=addeps(N,3,eps0,eps1);
Zm=zeros(2*m-1);

    Z1=intval(zeros(1,N_ind));
       
    for s=1:N_ind
        s_al=indeces(1,s);
        s_j=indeces(2,s);
        for t=1:3*(s_al-1)     % t_al is at most s_al
            t_al=indeces(1,t);
            t_j=indeces(2,t);
            
            Gamma=Gammacell{s_al,t_al,s_j,t_j};
            if ~isempty(Gamma)
               
                MatA=Amcell{s,s};
                
                Z1(s)=Z1(s)+computeZ1_withdiag(Gamma,intval(s_al),intval(MatA),ilambda);
                if Z1(s)>1
                    disp('error: Z1>1');
                    return
                end
                if ~isdiag(Gamma)
                    MatA=cat(3,Amcell{:,s});
                    nodiag=computeZ1_nodiag(Gamma,intval(MatA));
                    nodiag(s)=0;
                    Z1=Z1+nodiag;
                end
            end
            
        end
             
        Sumeps0=sum(squeeze(sum(addeps0(s_al,:,s_j,:))));
        if Sumeps0>0
            normMatA=A_oper_norm(:,s);
            normMatA(s)=max([normMatA(s),sup((twoipim2t+intval(s_al)*ilambda)^(-i1))]); 
           Z1=Z1+Sumeps0*normMatA.';
        end
        Sumeps1=sum(squeeze(sum(addeps1(s_al,:,s_j,:))));
        if Sumeps1>0
            normMatA=A_oper_norm(:,s);
            normMatA(s)=max([normMatA(s),sup((twoipim2t+intval(s_al)*ilambda)^(-i1))]);           
            Z1=Z1+Sumeps1*normMatA.';
        end
        
        
    end
    

    
    
display(['max of Z1 = ',num2str( norm(Z1.sup,inf))])
%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%  Z2 bound %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   

V=repmat([i0;i2;i2],N-1,1).*reshape(repmat([i0,i0,intval(1:1:N-3)],3,1),[],1);

normA=A_oper_norm;
for q=1:N_ind
   normA(q,q)= max([normA(q,q),sup((twoipim2t+intval(indeces(1,q))*ilambda)^(-i1))]);   %(i2*ipi*1i*intval(m)/(i2*iT)
end
Z2=intval(normA)*V;
Z2=Z2+10^-15;   % to avoid Z2=0
display(['max of Z2 = ',num2str( norm(Z2.sup,inf))])

ip=[Z2.sup sup(Z0)+sup(Z1).'-1 sup(Y).'];
p=mid(ip);



I=zeros(size(p,1),2);
for k=1:size(p,1)
    R=roots(p(k,:));
    R=sort(R);
    Int=R';
    I(k,:)=Int;
end

I=[max(I(:,1)) min(I(:,2))];

if norm(imag(I))>0
    display('FAILURE !')
    I=[-1 1];
    success=0;
elseif I(1)<0
    display('FAILURE !')
    I=[-1 1];
    success=0;
else    
   
    r=I(1)*1.1;
    ir=intval(r);
    pr=p(:,1)*ir^2+p(:,2)*ir+p(:,3);
    if max(sup(pr))<0
        display('SUCCESS !')
      
    else
        display('FAILURE ! max(sup(pr))>=0')
    end
    success=1;
end
%%%%%%%%%%%%%%%%%%%
    
  

%%%%%%%%%%%%%
function norm_Z=computeZ1_nodiag(tildemat,MatA)
                        
                           Bhat=tildemat(m+1:end,1:m-1);
                           Chat=tildemat(1:m-1,m+1:end);
                           B=zeros(2*m-1);
                           C=B;
                           B(1:m-1,m+1:end)=Bhat;
                           C(m+1:end,1:m-1)=Chat;
                           for ii=1:size(MatA,3)
                               Prod=[MatA(:,:,ii)*intval(B),Zm,MatA(:,:,ii)*intval(C)];
%                           
                               norm_Z(ii)=norm_dual(Prod,nu);
                           end

                             
    end
%%%%%%%%%%%%%%%%%%

function normZ=computeZ1_withdiag(E,q_al,A,lambda)
               ilambda=intval(lambda);
              
               ql=intval(q_al)*ilambda;
               D1=sparse(diag([ twoipi2t*intval([-3*m+2:1:-m])+ql].^(-i1)));
               D2=sparse(diag([ twoipi2t*intval([-5*m+3:1:-3*m+1])+ql].^(-i1)));
               D3=sparse(diag([ twoipi2t*intval([-7*m+4:1:-5*m+2])+ql].^(-i1)));
               H1=sparse(diag([ twoipi2t*intval([m:1:3*m-2])+ql].^(-i1)));
               H2=sparse(diag([ twoipi2t*intval([3*m-1:1:5*m-3])+ql].^(-i1)));
               H3=sparse(diag([ twoipi2t*intval([5*m-2:1:7*m-4])+ql].^(-i1)));
        
               Bhat=E(m+1:end,1:m-1);
               Chat=E(1:m-1,m+1:end);
               B=zeros(2*m-1);
               C=B;
               B(1:m-1,m+1:end)=Bhat;
               C(m+1:end,1:m-1)=Chat;
               B=intval(B);
               C=intval(C);
               E=intval(E);
               
               M=[D2*C,Zm,Zm;D1*E,D1*C,Zm;A*B,Zm,A*C;Zm,H1*B,H1*E;Zm,Zm,H2*B];
               V1=[D3*C;D2*E;D1*B];
               V2=[H1*C;H2*E;H3*B];
               normZ=max([norm_dual(M,nu),norm_dual(V1,nu),norm_dual(V2,nu)]);
        
end
end     % iniziale
      
function Nor=norm_nu(a,nu)
if size(a,1)==1
    a=a.';
end
inu=intval(nu);
m=(length(a)+1)/2;

Nor=abs(a)*(inu.^intval(abs(-m+1:1:m-1))).';
end

function Nor=norm_dual(A,nu)
%Assume A maps bi-sequences in bi-sequences
m1=(size(A,1)+1)/2;
m2=(size(A,2)+1)/2;
inu=intval(nu);

K=sum(abs(A).*repmat(inu.^intval(abs(-m1+1:1:m1-1)).',1,size(A,2)),1);
Nor=max(sup([K./(inu.^intval(abs(-m2+1:1:m2-1)))]));



end
 %%%%%%%%%
 function cellA=tildeAcellfun(alphas)
 m=(length(alphas(1).fc(1,:))+1)/2;
 C=size(alphas,2);
 cellA=cell(3,C);
 for c=0:C-1
      A=alphas(c+1).fc;
      A=[zeros(3,m-1),A,zeros(3,m-1)];
      center=2*m-1;
     for k=1:size(alphas(1).fc,1)

        a=A(k,:);
         cellA{k,c+1}=a(-repmat(-(m-1):1:m-1,2*m-1,1)+repmat([-(m-1):1:m-1].',1,2*m-1)+center); 
     end
 end
 end
 
     
 function  Gammacell=fungammacell(tildeAcell,N,dim,m,sigma,rho,beta)
 Gammacell=cell(N,N,dim,dim);
 
 I=eye(2*m-1);
 MC=mat2cell(sigma*[I;-I],[2*m-1,2*m-1],2*m-1);
 rhoI=rho*I;
 betaI=beta*I;
 for j=1:3
    sj=j;
    switch sj
        case 1        
            for al=2:N
                  Gammacell(al,al,1,1:2)=MC;
            end
           
              
        case 2
              for al=2:N 
                 s_al=[al:N];
                 Gammacell(s_al,al,sj,1)=tildeAcell(3,s_al-al+1);
                 Gammacell(s_al,al,sj,3)=tildeAcell(1,s_al-al+1);
                 Gammacell{al,al,sj,1}=  Gammacell{al,al,sj,1}-rhoI;
                 Gammacell{al,al,sj,2}=I;
              end
        case 3
            for al=2:N 
                 s_al=al:N;
                 Gammacell(s_al,al,sj,1)=cellfun(@(x) -x,tildeAcell(2,s_al-al+1),'UniformOutput',false);
                 Gammacell(s_al,al,sj,2)=cellfun(@(x) -x,tildeAcell(1,s_al-al+1),'UniformOutput',false);
                 Gammacell{al,al,sj,3}= betaI;
                 
            end
    end
 end
 
 end
 function [addeps0,addeps1]=addeps(N,dim,eps0,eps1)
 addeps0=intval(zeros(N,N,dim,dim));
 addeps1=intval(zeros(N,N,dim,dim));
 for al=2:N
    addeps0(al,al,2,[1,3])=[eps0(3),eps0(1)];
    addeps0(al,al,3,[1,2])=[eps0(2),eps0(1)];
    addeps1(al,al-1,2,[1,3])=[eps1(3),eps1(1)];
    addeps1(al,al-1,3,[1,2])=[eps1(2),eps1(1)];
 end
 end
 
