function [r,success,Ranalytic]=rad_poly_analytic_lorenz(x,gamma0_phase,par,k0,nu)

i0=intval(0);
i1=intval(1);
i2=intval(2);
i3=intval(3);
x=intval(x);
gamma0_phase=intval(gamma0_phase);

sigma=intval(par(1));
rho=intval(par(2));
beta=intval(par(3));

display(['nu = ',num2str(nu)])
nu=intval(nu);

m=(length(x)+2)/6; %%% N = m-1
omega=x(1);

a1=x(2:2*m);       %%% Complex Fourier coefficients of u1
a2=x(2*m+1:4*m-1); %%% Complex Fourier coefficients of u2
a3=x(4*m:6*m-2);   %%% Complex Fourier coefficients of u3

nu_power = nu.^intval(abs(-m+1:m-1));
a1_nu_norm=sum(abs(a1).*nu_power');
a2_nu_norm=sum(abs(a2).*nu_power');
a3_nu_norm=sum(abs(a3).*nu_power');
display(['The nu-norm of a1 is = ',num2str(a1_nu_norm.sup)])
display(['The nu-norm of a2 is = ',num2str(a2_nu_norm.sup)])
display(['The nu-norm of a3 is = ',num2str(a3_nu_norm.sup)])

Df = Df_comp_lorenz_int(x,gamma0_phase,par,k0);
Am=inv(Df.mid);
display(['norm of Am is = ',num2str(norm(Am))])

%%%%%%%%%
%%% Y %%%
%%%%%%%%%

%%% The use of m1 should be used to compute the f and the norms

a1_extended=[intval(zeros(m-1,1));a1;intval(zeros(m-1,1))];
a2_extended=[intval(zeros(m-1,1));a2;intval(zeros(m-1,1))];
a3_extended=[intval(zeros(m-1,1));a3;intval(zeros(m-1,1))];

x_extended = [omega;a1_extended;a2_extended;a3_extended];
f = f_comp_lorenz_int(x_extended,gamma0_phase,par,k0); 
fN = [f(1);f(m+1:3*m-1);f(5*m-2:7*m-4);f(9*m-5:11*m-7)];

yN=intval(Am)*fN;

yN1=yN(2:2*m);       
yN2=yN(2*m+1:4*m-1); 
yN3=yN(4*m:6*m-2);

Y0 = sup(abs(yN(1)));

yN1_nu_norm=sum(abs(yN1).*nu_power');
yN2_nu_norm=sum(abs(yN2).*nu_power');
yN3_nu_norm=sum(abs(yN3).*nu_power');

nu_power_extended = [nu.^intval(abs(-2*m+2:-m)');nu.^intval(abs(m:2*m-2)')];
omega_k_extended = real(omega)*intval([abs(-2*m+2:-m)';abs(m:2*m-2)']);
y_ext1_nu_norm=sum(abs([f(2:m);f(3*m:4*m-2)]).*nu_power_extended./omega_k_extended);
y_ext2_nu_norm=sum(abs([f(4*m-1:5*m-3);f(7*m-3:8*m-5)]).*nu_power_extended./omega_k_extended);
y_ext3_nu_norm=sum(abs([f(8*m-4:9*m-6);f(11*m-6:12*m-8)]).*nu_power_extended./omega_k_extended);

Y1 = sup(yN1_nu_norm + y_ext1_nu_norm);
Y2 = sup(yN2_nu_norm + y_ext2_nu_norm);
Y3 = sup(yN3_nu_norm + y_ext3_nu_norm);

display(['The nu-norm of Y0 is = ',num2str(Y0)])
display(['The nu-norm of Y1 is = ',num2str(Y1)])
display(['The nu-norm of Y2 is = ',num2str(Y2)])
display(['The nu-norm of Y3 is = ',num2str(Y3)])

Y=[Y0;Y1;Y2;Y3];

%%%%%%%%%%%%%%%%%%%%%%%
%%% Z0, Z1, Z2 & Z3 %%%
%%%%%%%%%%%%%%%%%%%%%%%

%%% Z0 %%%

B=abs(intval(eye(6*m-2))-intval(Am)*Df);

Z0=intval(zeros(4,1));

B_omega_0 = B(1,1);
B_a1_0 = max(sup(B(1,2:2*m)./nu_power));
B_a2_0 = max(sup(B(1,2*m+1:4*m-1)./nu_power));
B_a3_0 = max(sup(B(1,4*m:6*m-2)./nu_power));

Z0(1) = B_omega_0 + B_a1_0 + B_a2_0 + B_a3_0;

B_omega_1 = sup(sum(B(2:2*m,1).*nu_power'));
B_omega_2 = sup(sum(B(2*m+1:4*m-1,1).*nu_power'));
B_omega_3 = sup(sum(B(4*m:6*m-2,1).*nu_power')); 

B11 = B(2:2*m,2:2*m);
B21 = B(2:2*m,2*m+1:4*m-1);
B31 = B(2:2*m,4*m:6*m-2);
B12 = B(2*m+1:4*m-1,2:2*m);
B22 = B(2*m+1:4*m-1,2*m+1:4*m-1);
B32 = B(2*m+1:4*m-1,4*m:6*m-2);
B13 = B(4*m:6*m-2,2:2*m);
B23 = B(4*m:6*m-2,2*m+1:4*m-1);
B33 = B(4*m:6*m-2,4*m:6*m-2);

B_a1_1 = max(sup(sum(B11.*repmat(nu_power,2*m-1,1)')./nu_power));
B_a2_1 = max(sup(sum(B21.*repmat(nu_power,2*m-1,1)')./nu_power));
B_a3_1 = max(sup(sum(B31.*repmat(nu_power,2*m-1,1)')./nu_power));

B_a1_2 = max(sup(sum(B12.*repmat(nu_power,2*m-1,1)')./nu_power));
B_a2_2 = max(sup(sum(B22.*repmat(nu_power,2*m-1,1)')./nu_power));
B_a3_2 = max(sup(sum(B32.*repmat(nu_power,2*m-1,1)')./nu_power));

B_a1_3 = max(sup(sum(B13.*repmat(nu_power,2*m-1,1)')./nu_power));
B_a2_3 = max(sup(sum(B23.*repmat(nu_power,2*m-1,1)')./nu_power));
B_a3_3 = max(sup(sum(B33.*repmat(nu_power,2*m-1,1)')./nu_power));

Z0(2) = B_omega_1 + B_a1_1 + B_a2_1 + B_a3_1;
Z0(3) = B_omega_2 + B_a1_2 + B_a2_2 + B_a3_2;
Z0(4) = B_omega_3 + B_a1_3 + B_a2_3 + B_a3_3;

display(['The nu-norm of Z0_1 is = ',num2str(Z0(1).sup)])
display(['The nu-norm of Z0_2 is = ',num2str(Z0(2).sup)])
display(['The nu-norm of Z0_3 is = ',num2str(Z0(3).sup)])
display(['The nu-norm of Z0_4 is = ',num2str(Z0(4).sup)])

%%% Z1 %%%

Z1=intval(zeros(4,1));
Am=intval(Am);

A20=abs(Am(1,2*m+1:4*m-1));
A30=abs(Am(1,4*m:6*m-2));

A11 = abs(Am(2:2*m,2:2*m));
A21 = abs(Am(2:2*m,2*m+1:4*m-1));
A31 = abs(Am(2:2*m,4*m:6*m-2));
A12 = abs(Am(2*m+1:4*m-1,2:2*m));
A22 = abs(Am(2*m+1:4*m-1,2*m+1:4*m-1));
A32 = abs(Am(2*m+1:4*m-1,4*m:6*m-2));
A13 = abs(Am(4*m:6*m-2,2:2*m));
A23 = abs(Am(4*m:6*m-2,2*m+1:4*m-1));
A33 = abs(Am(4*m:6*m-2,4*m:6*m-2));

ell_hat_a1=intval(zeros(2*m-1,1));
ell_hat_a2=intval(zeros(2*m-1,1));
ell_hat_a3=intval(zeros(2*m-1,1));

for k=-m+1:-1
    ell_hat_a1(k+m)=max(sup(nu.^intval(-(m-1+abs((k:-1))')).*abs(a1(k-(k:-1)+(m-1)+m))));
    ell_hat_a2(k+m)=max(sup(nu.^intval(-(m-1+abs((k:-1))')).*abs(a2(k-(k:-1)+(m-1)+m))));
    ell_hat_a3(k+m)=max(sup(nu.^intval(-(m-1+abs((k:-1))')).*abs(a3(k-(k:-1)+(m-1)+m))));
end

for k=1:m-1
    ell_hat_a1(k+m)=max(sup(nu.^intval(-(m-1+(1:k)')).*abs(a1(k-(1:k)-(m-1)+m))));
    ell_hat_a2(k+m)=max(sup(nu.^intval(-(m-1+(1:k)')).*abs(a2(k-(1:k)-(m-1)+m))));
    ell_hat_a3(k+m)=max(sup(nu.^intval(-(m-1+(1:k)')).*abs(a3(k-(1:k)-(m-1)+m))));
end

beta3_a2_0=sum((A20*ell_hat_a3).*nu_power');
beta2_a3_0=sum((A30*ell_hat_a2).*nu_power');
beta1_a3_0=sum((A30*ell_hat_a1).*nu_power');
beta1_a2_0=sum((A20*ell_hat_a1).*nu_power');

beta3_a2_2=sum((A22*ell_hat_a3).*nu_power');
beta2_a3_2=sum((A32*ell_hat_a2).*nu_power');
beta3_a2_1=sum((A21*ell_hat_a3).*nu_power');
beta2_a3_1=sum((A31*ell_hat_a2).*nu_power');
beta2_a3_3=sum((A33*ell_hat_a2).*nu_power');
beta3_a2_3=sum((A23*ell_hat_a3).*nu_power');
beta1_a3_1=sum((A31*ell_hat_a1).*nu_power');
beta1_a3_2=sum((A32*ell_hat_a1).*nu_power');
beta1_a3_3=sum((A33*ell_hat_a1).*nu_power');
beta1_a2_1=sum((A23*ell_hat_a1).*nu_power');
beta1_a2_2=sum((A22*ell_hat_a1).*nu_power');
beta1_a2_3=sum((A23*ell_hat_a1).*nu_power');

Z1(1)=beta3_a2_0+beta2_a3_0+beta1_a3_0+beta1_a2_0;
Z1(2)=i2*abs(sigma)/(omega*intval(m))+beta3_a2_1+beta2_a3_1+beta1_a3_1+beta1_a2_1;
Z1(3)=(abs(rho)+i1+a3_nu_norm+a1_nu_norm)/(omega*intval(m))+beta3_a2_2+beta2_a3_2+beta1_a3_2+beta1_a2_2;
Z1(4)=(abs(beta)+a1_nu_norm+a2_nu_norm)/(omega*intval(m))+beta3_a2_3+beta2_a3_3+beta1_a3_3+beta1_a2_3;

display(['The nu-norm of Z1_1 is = ',num2str(Z1(1).sup)])
display(['The nu-norm of Z1_2 is = ',num2str(Z1(2).sup)])
display(['The nu-norm of Z1_3 is = ',num2str(Z1(3).sup)])
display(['The nu-norm of Z1_4 is = ',num2str(Z1(4).sup)])

%%% Z2 %%%

Z2=intval(zeros(4,1));

hat_B_a1_0 = max(sup(abs(Am(1,2:2*m))./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a2_0 = max(sup(abs(Am(1,2*m+1:4*m-1))./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a3_0 = max(sup(abs(Am(1,4*m:6*m-2))./nu_power.*intval(abs(-m+1:m-1))));

hat_B_a1_1 = max(sup(sum(A11.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a2_1 = max(sup(sum(A21.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a3_1 = max(sup(sum(A31.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));

hat_B_a1_2 = max(sup(sum(A12.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a2_2 = max(sup(sum(A22.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a3_2 = max(sup(sum(A32.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));

hat_B_a1_3 = max(sup(sum(A13.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a2_3 = max(sup(sum(A23.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));
hat_B_a3_3 = max(sup(sum(A33.*repmat(nu_power,2*m-1,1)')./nu_power.*intval(abs(-m+1:m-1))));

Z2(1)=i2*(hat_B_a1_0+hat_B_a2_0+hat_B_a3_0+B_a2_0+B_a3_0);
Z2(2)=i2*(max(sup([hat_B_a1_1,i1/omega]))+hat_B_a2_1+hat_B_a3_1+B_a3_1+B_a2_1);
Z2(3)=i2*(max(sup([hat_B_a2_2,i1/omega]))+hat_B_a1_2+hat_B_a3_2+max(sup([B_a2_2,i1/(omega*intval(m))]))+B_a3_2);
Z2(4)=i2*(max(sup([hat_B_a3_3,i1/omega]))+hat_B_a1_3+hat_B_a2_3+max(sup([B_a3_3,i1/(omega*intval(m))]))+B_a2_3);

display(['The nu-norm of Z2_1 is = ',num2str(Z2(1).sup)])
display(['The nu-norm of Z2_2 is = ',num2str(Z2(2).sup)])
display(['The nu-norm of Z2_3 is = ',num2str(Z2(3).sup)])
display(['The nu-norm of Z2_4 is = ',num2str(Z2(4).sup)])

%%%%%%%%%%%%%%%%%%%%%%%%
%%% Radii polynomial %%%
%%%%%%%%%%%%%%%%%%%%%%%%

p=real([Z2.sup Z0.sup+Z1.sup-1 Y]);

I=zeros(4,2);
for k=1:4
    R=roots(p(k,:));
    R=sort(R);
    Int=R';
    I(k,:)=Int;
end

I=[max(I(:,1)) min(I(:,2))];
Ranalytic=0;
if norm(imag(I))>0
    display('FAILURE !')
    I=[-1 1];
    success=0;
elseif I(1)<0
    display('FAILURE !')
    I=[-1 1];
    success=0;
else    
    r=1.1*I(1);%sum(rts)/2;
    ir=intval(r);
    pr=intval(p(:,1))*ir^i2+intval(p(:,2))*ir+intval(p(:,3));
    if max(sup(pr))<0
        display('SUCCESS !')
        display(['r = ',num2str(r)])
    else
        display('FAILURE ! max(sup(pr))>=0')
    end
    Ranalytic=log(nu.mid)/omega.mid;
    display(['SUCCESS ! The radius of analyticity is = ',num2str(Ranalytic)])
    display(['I = ',num2str(I)])
    success=1;
end

end

function [f] = f_comp_lorenz_int(x,gamma0_phase,par,k0)

% input: x = [omega;a1;a2;a3], where for i=1,2,3, 
%        ai=(ai_{-N},...,ai_{-1},ai_0,ai_1,...,ai_{N}) \in C^{2N+1}
%        k0 : 2*k0+1 is the number of Fourier modes we keep to evaluate the
%             phase condition 

% output  f = [f0;f1;f2;f3], where 
%        f0 = phase condition, and for i=1,2,3
%        fi = (fi_{-N},...,fi_{-1},fi_0,fi_1,...,fi_{N}) \in C^{2N+1}
% f : R x C^(6N+3) --> R x C^(6N+3).

sigma=intval(par(1));
rho=intval(par(2));
beta=intval(par(3));

gamma0_phase_bar=gamma0_phase(:,1);
gamma0_phase_dot=gamma0_phase(:,2);

m=(length(x)+2)/6; %%% N = m-1
omega=x(1);

a1=x(2:2*m);       %%% Complex Fourier coefficients of u1
a2=x(2*m+1:4*m-1); %%% Complex Fourier coefficients of u2
a3=x(4*m:6*m-2);   %%% Complex Fourier coefficients of u3

conv12=quadratic_sum_complex_int(a1,a2);
conv13=quadratic_sum_complex_int(a1,a3);

%%% Phase condition
gamma_0=[sum(a1(m-k0:m+k0));sum(a2(m-k0:m+k0));sum(a3(m-k0:m+k0))];
phase=gamma0_phase_dot'*(gamma0_phase_bar-gamma_0);

%%% Linear part
ikomega=1i*(-m+1:m-1)'*omega;

%%% Evaluating f
f=[phase;-ikomega.*a1+sigma*(a2-a1);-ikomega.*a2+(rho*a1-a2-conv13);-ikomega.*a3+(-beta*a3+conv12)];

end




function [Df] = Df_comp_lorenz_int(x,gamma0_phase,par,k0)

% input: x = [omega,a1,a2,a3], where for i=1,2,3, 
%  ai=(ai_{-N},...,ai_{-1},ai_0,ai_1,...,ai_{N}) \in C^{2N+1}
%
% output Df = [ df_0/d_omega df_0/da_1 df_0/da_2 df_0/da_3 ;
%               df_1/d_omega df_1/da_1 df_1/da_2 df_1/da_3 ;
%               df_2/d_omega df_2/da_1 df_2/da_2 df_2/da_3 ;
%               df_3/d_omega df_3/da_1 df_3/da_2 df_3/da_3  ]
%
%  where for i=1,2,3,
%       fi=(fi_{-N},...,fi_{-1},fi_0,fi_1,...,fi_{N}) \in C^{2N+1}
    
sigma=intval(par(1));
rho=intval(par(2));
beta=intval(par(3));

gamma0_phase_dot=gamma0_phase(:,2);

m=(length(x)+2)/6; %%% N = m-1

Df = intval(zeros(6*m-2));

omega=x(1);        %%% Frequency variable
a1=x(2:2*m);       %%% Complex Fourier coefficients of u1
a2=x(2*m+1:4*m-1); %%% Complex Fourier coefficients of u2
a3=x(4*m:6*m-2);   %%% Complex Fourier coefficients of u3

ikomega=1i*(-m+1:m-1)'*omega;
ik=1i*intval((-m+1:m-1)');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Derivatives of the quadratic terms in df_i/da_j %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

da1a3_da1=intval(zeros(2*m-1));
da1a3_da3=intval(zeros(2*m-1));
da1a2_da1=intval(zeros(2*m-1));
da1a2_da2=intval(zeros(2*m-1));

a1_extended=[intval(zeros(1,m-1)) reshape(a1,1,2*m-1) intval(zeros(1,m-1))];
a2_extended=[intval(zeros(1,m-1)) reshape(a2,1,2*m-1) intval(zeros(1,m-1))];
a3_extended=[intval(zeros(1,m-1)) reshape(a3,1,2*m-1) intval(zeros(1,m-1))];

for k=-m+1:m-1
    da1a3_da1(k+m,:)=a3_extended(k+2*m-1-(-m+1:m-1));
    da1a3_da3(k+m,:)=a1_extended(k+2*m-1-(-m+1:m-1));
    da1a2_da1(k+m,:)=a2_extended(k+2*m-1-(-m+1:m-1));
    da1a2_da2(k+m,:)=a1_extended(k+2*m-1-(-m+1:m-1));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_0/da_i, i=1,2,3 [First row] %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ones_k0=intval(ones(1,2*k0+1));

%%% df_0/da_1 %%%
Df(1,m-k0+1:m+k0+1)=-gamma0_phase_dot(1)*ones_k0;

%%% df_0/da_2 %%%
Df(1,3*m-k0:3*m+k0)=-gamma0_phase_dot(2)*ones_k0;

%%% df_0/da_3 %%%
Df(1,5*m-k0-1:5*m+k0-1)=-gamma0_phase_dot(3)*ones_k0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_i/d_omega, i=1,2,3 [First column] %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Df(2:2*m,1)=-ik.*a1;
Df(2*m+1:4*m-1,1)=-ik.*a2;
Df(4*m:6*m-2,1)=-ik.*a3;

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_1/da_1 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(2:2*m,2:2*m)=diag(-ikomega-sigma);

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_1/da_2 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(2:2*m,2*m+1:4*m-1)=diag(sigma*intval(ones(1,2*m-1)));

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_2/da_1 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(2*m+1:4*m-1,2:2*m)=diag(rho*intval(ones(1,2*m-1)))-da1a3_da1;

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_2/da_2 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(2*m+1:4*m-1,2*m+1:4*m-1)=diag(-ikomega-1);

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_2/da_3 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(2*m+1:4*m-1,4*m:6*m-2)=-da1a3_da3;

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_3/da_1 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(4*m:6*m-2,2:2*m)=da1a2_da1;

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_3/da_2 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(4*m:6*m-2,2*m+1:4*m-1)=da1a2_da2;

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% df_3/da_3 %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

Df(4*m:6*m-2,4*m:6*m-2)=diag(-ikomega-beta);

end


function [s]=quadratic_sum_complex_int(a,b)

m=(length(a)+1)/2;

B=intval(zeros(2*m-1));

tb=[intval(zeros(m-1,1));flipdim(b,1);intval(zeros(m-1,1))].';

for k=-m+1:m-1
    B(k+m,:)=tb((-m+1:m-1)-k+(2*m-1));
end

s=B*a;

end